'use strict'

const fs = require('fs')
const path = require('path')

const express = require('express')
const router = express.Router()

const prefix = ''

const ROUTERS_PATH = './routers/'

function useRouter (customerRouters, controllerPath) {
  for (let key in customerRouters) {
    let item = customerRouters[key]
    let pid = process.pid
    let method = item.method
    let uri = item.uri
    let action = item.action

    let methods = []

    methods.push(action)

    router[method](prefix + uri, ...methods)

    Log.app('make router succeed.', {'pid': pid, 'http-method': method, 'uri': uri, 'file-path': controllerPath, 'action': action.name})
  }
}

/**
 * read customer routers file recursive
 */
function readAllRouterFile (routersPath = path.resolve(ROUTERS_PATH)) {
  let list = fs.readdirSync(routersPath)

  list.forEach(item => {
    let resolvePath = routersPath + '/' + item
    let stat = fs.statSync(resolvePath)
    let isDir = stat.isDirectory()
    let isFile = stat.isFile()

    if (isDir) {
      readAllRouterFile(resolvePath)
    } else if (isFile) {
      useRouter(require(resolvePath), resolvePath)
    }
  })
}

readAllRouterFile()

router.use(function (req, res) {
  res.status(404).json({'error': 'request address not found.'})
})

module.exports = router
